﻿Type=Activity
Version=6.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'   ║
'   ║  		a) Realtime  --> Event driven access to data (the better choice in most cases)
'   ║
'   ║                        In the "Files"-folder is a file with testdata that you MAY IMPORT in the Firebase console:    
'   ║                        									 "fir-quickstartsforandroid-testdata.json"
'   ║
'   ║                        *** BE AWARE THAT AN IMPORT WILL DELETE ALL OTHER EXISTING DATA 
'   ║                            IN THE FIREBASE DATABASE NODE THAT IS SELECTED ***
'
'    Good to read: 
'		a) https://highlyscalable.wordpress.com/2012/03/01/nosql-data-modeling-techniques/
'		b) https://www.airpair.com/firebase/posts/firebase-building-realtime-app
'		c) https://www.airpair.com/firebase/posts/structuring-your-firebase-data
'

#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

#Region --- Activity parts ---

Sub Process_Globals
	'Private nativeMe As JavaObject	
End Sub

Sub Globals
	Dim mDatabase As DatabaseReference
 	Dim strTopNode As String = ""
 
	Private btnInitNew As Button
	Private btnSend As Button
	Private edtBody As EditText
	Private edtPath As EditText
	Private edtTitle As EditText
	Private Label1 As Label
	Private Label2 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label5 As Label
	Private Label6 As Label
	Private lblInfo As Label
	Private lblSnapshot As Label
	Private lblUser As Label
	Private lblUserId As Label
	Private Panel1 As Panel
	Private Panel2 As Panel
	Private Panel3 As Panel
	Private Panel4 As Panel
	Private Panel7 As Panel
	Private edtPathSet As EditText
	Private edtValSet As EditText
	Private btnSet As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Dim sv As ScrollView : sv.Initialize(200%y)
	sv.Panel.LoadLayout("testfibart")
	sv.Panel.Color = Colors.White
	
	Activity.AddView(sv, 0, 0, 100%x, 100%y)

	Panel1.Width = 100%x -Panel1.Left *2
	Panel2.Width = 100%x -Panel2.Left *2
	Panel3.Width = 100%x -Panel3.Left *2
	Panel4.Width = 100%x -Panel4.Left *2
	Panel7.Width = 100%x -Panel7.Left *2

	lblUser.Width   = Panel7.Width -lblUser.Left -16dip
	lblUserId.Width = Panel7.Width -lblUserId.Left -16dip

	edtPath.Width = Panel3.Width -edtPath.Left -16dip
	
	lblSnapshot.Width = Panel4.Width -lblSnapshot.Left *2

	edtPathSet.Width = Panel2.Width -edtPathSet.Left -16dip
	edtValSet.Width  = Panel2.Width -edtValSet.Left -16dip
	btnSet.Left = Panel2.Width -btnSet.Width -16dip

	edtTitle.Width = Panel1.Width -edtTitle.Left -16dip
	edtBody.Width  = Panel1.Width -edtBody.Left -16dip
	btnSend.Left = Panel1.Width -btnSend.Width -16dip
	
	btnInitNew.Left = edtPath.Left +edtPath.Width -btnInitNew.Width

End Sub

Sub Activity_Resume
	If Starter.strFirebaseProjectId.Contains(" ") Or Starter.strFirebaseProjectId.Contains(" ") Then 
		Msgbox("*** You have to set up your Firebase parameters in the Starter-module", "Not ready for testing!")
		Return
	End If


End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub Initialize
	Log("#-testfibart.Initialize")	
	showFiBaUser	
	
	edtTitle.Hint = "Post title"
	edtBody.Hint  = "Your message"

	edtTitle.Text = "🔥 Testtitle with NOW -> " & DateTime.Now
	edtBody.Text  = "Testmessage with now -> " & DateTime.Now
	
	edtPath.Text = "testnode1" ' This is the top node for your experiments

	ReferenceInit(edtPath.Text)

End Sub

Sub btnInitNew_Click
Log("#-btnInitNew_Click")	
	lblSnapshot.Text = "(running)"
	ReferenceInit(edtPath.Text)
End Sub

Sub showFiBaUser
	If Starter.strFirebaseSignedInUser.Length = 0 Then 
		lblUser.Text   = "(empty)"
		lblUserId.Text = "(empty)"
	Else
		lblUser.Text   = Starter.strFirebaseSignedInUser 
		lblUserId.Text = Starter.strFirebaseSignedInUserID
	End If
End Sub

' Just a few little helpers
Sub raJsonToMap(strJSON As String) As Map
    Dim jMap As Map         : jMap.Initialize
    Dim JSON As JSONParser    : JSON.Initialize(strJSON)
    jMap = JSON.NextObject
    Return jMap
End Sub
Sub raMapToJson(mapX As Map) As String
	Dim jsonGen As JSONGenerator
	jsonGen.Initialize(mapX)
	Return jsonGen.ToString
End Sub
Sub raJsonPretty(strJson As String) As String
	Dim j As JSONGenerator
	j.Initialize(raJsonToMap(strJson))
	Return j.ToPrettyString(4)
End Sub
#End Region
' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 

#Region -- Firebase REALTIME Database --

Sub ReferenceInit(strNode As String)
	Log("#-ReferenceInit, strNode=" & strTopNode)
	strTopNode = strNode
	
	Try
		mDatabase.Initialize("mDatabase", Starter.FiBaRtDb.getReferencefromUrl(Starter.strFirebaseProjectRefUrl & "/" & strTopNode & "/") )
	Catch
		Log("#-  init error!")
		Log("#-  strFirebaseProjectId=" & Starter.strFirebaseProjectId)
		Log("#-  strFirebaseProjectRefUrl=" & Starter.strFirebaseProjectRefUrl)
		Log("#-  You need To setup your project values for strFirebaseProjectId and strFirebaseDbSecret in the module 'Starter'")
		Activity.Finish
	End Try
	
	mDatabase.addChildEventListener
	mDatabase.addListenerForSingleValueEvent
	mDatabase.addValueEventListener
	mDatabase.goOnline
	
	Log("#-  mDatabase.Root=" & mDatabase.Root)
	
End Sub

Sub mDatabase_onCancelled(errnum As Int,error As String, errObj As Object)
	Log("#-mDatabase_onCancelled, errnum=" & errnum)	
	
End Sub

Sub mDatabase_onChildAdded(snapshot As Object, child As String)
	Log("#-mDatabase_onChildAdded, child=" & child)	
	Dim dataSnapshot As DataSnapshot = snapshot
	Dim strX As String = dataSnapshot.Value
	Log("#-  dataSnapshot.ChildrenCount=" & dataSnapshot.ChildrenCount)
	Try
		Log("#-  dataSnapshot.Value=" & strX.SubString2(0, 64) )
		'Log("#-  dataSnapshot.Value=" & strX)
	Catch
		Log("#-  err" )
	End Try
	
End Sub

Sub mDatabase_onChildChanged(snapshot As Object, child As String)
	Log("#-mDatabase_onChildChanged, child=" & child)	
	
End Sub

Sub mDatabase_onChildMoved(snapshot As Object, child As String)
	Log("#-mDatabase_onChildMoved, child=" & child)	
	
End Sub

Sub mDatabase_onChildRemoved(snapshot As Object)
	Log("#-mDatabase_onChildRemoved")	
	
End Sub

Sub mDatabase_onComplete(errorCode As Int, errorMessage As String)
	Log("#-mDatabase_onComplete, errorCode=" & errorCode)	
	
End Sub

Sub mDatabase_onDataChange(snapshot As Object)
	Log("#-mDatabase_onDataChange")	
	Dim dataSnapshot As DataSnapshot = snapshot
	Dim strX As String = dataSnapshot.Value
	Log("#-  dataSnapshot.ChildrenCount=" & dataSnapshot.ChildrenCount)
	Try
		Log("#-  dataSnapshot.Value=" & strX.SubString2(0, 64) )
		'Log("#-  dataSnapshot.Value=" & strX)
	Catch
		Log("#-  err" )
	End Try
	
	lblSnapshot.Text = strX
	
End Sub

Sub lblSnapshot_Click
	Msgbox(lblSnapshot.Text, "Content of Snapshot")
End Sub

' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 
' POST
' ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- ##- 
Sub btnSend_Click
	Log("#-btnSend_Click")
	submitPost(edtTitle.Text, edtBody.Text)
End Sub
 
Sub submitPost(strTitle As String, strBody As String)
	Log("#-submitPost, strTitle=" & strTitle & ", strBody=" & strBody)
	If strTitle.Length < 1 Then
		edtTitle.Hint = "Enter a title"
		edtTitle.HintColor = Colors.Red
		Return
	Else
		edtTitle.HintColor = Colors.Gray
	End If
	
	If strBody.Length < 1 Then
		edtBody.Hint = "Enter a message"
		edtBody.HintColor = Colors.Red
		Return
	Else
		edtBody.HintColor = Colors.Gray
	End If
	
	Dim bolWpOk As Boolean = writeNewPost(Starter.strFirebaseSignedInUserID, Starter.strFirebaseSignedInUser, strTitle, strBody)
	Log("#-  bolWpOk=" & bolWpOk)
	
End Sub

Sub writeNewPost(strUid As String, strUNam As String, strTitle As String, strBody As String) As Boolean 
	Log("#-writeNewPost, strUid=" & strUid & ", strUNam=" & strUNam & ", strTitle=" & strTitle & ", strBody=" & strBody)	
  
 	' ───────────────────────────────────
 	' Variant 1:  Original in JAVA from here --> https://github.com/firebase/quickstart-android/blob/master/database/app/src/main/java/com/google/firebase/quickstart/database/NewPostActivity.java
	' ───────────────────────────────────
	'// [START write_fan_out]
 	'        // Create new post at  /user-posts/$userid/$postid 
	'        // and at              /posts/$postid 
	'		 // simultaneously
	'        String key = mDatabase.child("posts").push().getKey();
	'        Post post = new Post(userId, username, title, body);
	'        Map<String, Object> postValues = post.toMap();
	'
	'        Map<String, Object> childUpdates = new HashMap<>();
	'        childUpdates.put("/posts/" + key, postValues);
	'        childUpdates.put("/user-posts/" + userId + "/" + key, postValues);
	'
	'        mDatabase.updateChildren(childUpdates);
	'// [END write_fan_out]

 
 	' ───────────────────────────────────
 	' Variant 2:  Original in JAVA from here --> https://firebase.google.com/docs/database/server/save-data#getting-the-unique-key-generated-by-push
	' ───────────────────────────────────
	'	 Public static class Post {
	'	    Public String author;
	'	    Public String title;
	'	    Public Post(String author, String title) {
	'	        // ...
	'	    }
	'	}
	'
	'	DatabaseReference postsRef = ref.child("posts");
	'	DatabaseReference newPostRef = postsRef.push();
	'	newPostRef.setValue(new Post("gracehop", "Announcing COBOL, a New Programming Language"));
	'
	'	// We can also chain the two calls together
	'	postsRef.push().setValue(new Post("alanisawesome", "The Turing Machine"));
	
	
	' 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 
	' Test with Variant 1
	' 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 
	Dim mapPostValues As Map 
	mapPostValues.Initialize
	mapPostValues.Put("Uid", "uidTEST") 'strUid)
	mapPostValues.Put("UNam", "unamTEST")'strUNam)
	mapPostValues.Put("Title", "TitleTEST")'strTitle)
	mapPostValues.Put("Body", "BodyTEST") 'strBody)
	Dim strPostValues As String = raMapToJson(mapPostValues)
	Log("#-  strPostValues=" & strPostValues)	

	Dim key As String = mDatabase.push   
	' Creates this --> 	' https://fbdbzzzz-xyxyxyx.firebaseio.com/testnode1/-KT4Xi6oGKr0wye-zOoO ' The last part this is what we need = OK
	'
	Log("#-  raw key=" & key)	
	' No key, no joy
	If key.Length < 2 Then 	
		Return False
	End If
	'
	' Extract the autogenerated optimized Firebase-key
	key = key.SubString(key.LastIndexOf("/") +1)  '#- creates this -->   -KT4Xi6oGKr0wye-zOoO
	Log("#-  key=" & key)	
	
	' Fanout the data to different paths ("NoSQL" recommendation for up to 1 million users)  --> https://firebase.googleblog.com/2015/10/client-side-fan-out-for-data-consistency_73.html
	Dim strUk1 As String = "/posts/" & key
	Dim strUk2 As String = "/user-posts/" & strUid & "/" & key
	Log("#-  strUk1=" & strUk1)	
	Log("#-  strUk2=" & strUk2)	
	
	Dim childUpdates As Map 
	childUpdates.Initialize
	childUpdates.Put(strUk1, strPostValues)
	childUpdates.Put(strUk2, strPostValues )
	
	' The JSON data that send up in a more readable format
	Log("#-  childUpdates=" & CRLF &  raJsonPretty(raMapToJson(childUpdates )) )
	' Copy and paste the output here to have a different look at the JSON data--> http://www.basic4ppc.com:51042/json/index.html
	
	mDatabase.updateChildren(childUpdates) 	' <<<<<<<<<<<<<<<<----here
	
	Return True
	' 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 🚩 -- 
	
End Sub

' »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  
' SET
' »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  »»  
Sub btnSet_Click
	Log("#-btnSet_Click")
	
	' ...
	
End Sub


#End Region
